<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->
<template>
  <div class="box">
    <div
      id="piChart"
      class="chart"
    />
  </div>
</template>
<script>
import echarts from 'echarts'
export default {
  name: 'PiChart',
  props: {
    chartId: {
      type: String,
      default: 'donutid'
    },
    name: {
      type: String,
      default: 'Pi Chart'
    },
    graphData: {
      type: Array,
      required: true
    },
    labelPos: {
      type: Number,
      required: true
    },
    legendName: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      myDoChart: {},
      option: {
        title: {
          text: this.name,
          textVerticalAlign: 'bottom',
          textAlign: 'center',
          bottom: 30,
          right: this.labelPos
        },
        tooltip: {
          trigger: 'item',
          formatter: '{b} : {c} ({d}%)'
        },
        legend: {
          orient: 'vertical',
          right: 0,
          bottom: 100,
          data: this.legendName
        },
        series: [
          {
            name: this.name,
            type: 'pie',
            radius: '55%',
            center: ['50%', '50%'],
            label: {
              formatter: '{c} ({d}%)'
            },
            color: ['#78ddcc', '#e94b0b', '#48b6cd', '#ec9308'],
            data: this.graphData,
            roseType: 'radius',
            animationType: 'scale',
            animationEasing: 'elasticOut',
            animationDelay: function (idx) {
              return Math.random() * 200
            }
          }
        ]
      }
    }
  },
  watch: {
    graphData (val) {
      this.myDoChart.setOption({
        title: {
          text: this.name,
          textVerticalAlign: 'bottom',
          textAlign: 'center',
          bottom: 30,
          right: this.labelPos
        },
        tooltip: {
          trigger: 'item',
          formatter: '{b} : {c} ({d}%)'
        },
        legend: {
          orient: 'vertical',
          right: 0,
          bottom: 100,
          data: this.legendName
        },
        series: [
          {
            name: this.name,
            type: 'pie',
            radius: '55%',
            center: ['50%', '50%'],
            label: {
              formatter: '{c} ({d}%)'
            },
            color: ['#78ddcc', '#e94b0b', '#48b6cd', '#ec9308'],
            data: this.graphData,
            roseType: 'radius',
            animationType: 'scale',
            animationEasing: 'elasticOut',
            animationDelay: function (idx) {
              return Math.random() * 200
            }
          }
        ]
      })
      this.myDoChart.resize()
    }
  },
  methods: {
    mapChart () {
      this.myDoChart = echarts.init(document.getElementById('piChart'))
      window.onresize = function () {
        this.myDoChart.resize()
      }
      this.myDoChart.setOption(this.option, true)
    }
  },
  mounted () {
    this.mapChart()
  }
}
</script>
<style scoped>
.box {
  height: 40vh;
}
.chart {
  position: relative;
  height: 100%;
  top: 5%;
  left: 10%;
}
</style>
